/* Autogenerated by mlir-tblgen; don't manually edit */

#ifdef GEN_PASS_DECL
// Generate declarations for all passes.
#define GEN_PASS_DECL_CONVERTROCKTOGPUPASS
#define GEN_PASS_DECL_EMULATEFP8EXTTRUNCPASS
#define GEN_PASS_DECL_GPUTOMIGRAPHXPASS
#define GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
#define GEN_PASS_DECL_ROCMLIRCUSTOMTOSATOLINALGPASS
#define GEN_PASS_DECL_TOSATOROCKPASS
#undef GEN_PASS_DECL
#endif // GEN_PASS_DECL

//===----------------------------------------------------------------------===//
// ConvertRockToGPUPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_CONVERTROCKTOGPUPASS
std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass();
#undef GEN_PASS_DECL_CONVERTROCKTOGPUPASS
#endif // GEN_PASS_DECL_CONVERTROCKTOGPUPASS
#ifdef GEN_PASS_DEF_CONVERTROCKTOGPUPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class ConvertRockToGPUPassBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ConvertRockToGPUPassBase;

  ConvertRockToGPUPassBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertRockToGPUPassBase(const ConvertRockToGPUPassBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}
  ConvertRockToGPUPassBase& operator=(const ConvertRockToGPUPassBase &) = delete;
  ConvertRockToGPUPassBase(ConvertRockToGPUPassBase &&) = delete;
  ConvertRockToGPUPassBase& operator=(ConvertRockToGPUPassBase &&) = delete;
  ~ConvertRockToGPUPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-rock-to-gpu");
  }
  ::llvm::StringRef getArgument() const override { return "convert-rock-to-gpu"; }

  ::llvm::StringRef getDescription() const override { return "Lower the operations from the Rock dialect into the GPU dialect"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertRockToGPUPass");
  }
  ::llvm::StringRef getName() const override { return "ConvertRockToGPUPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<rock::RockDialect>();
    registry.insert<amdgpu::AMDGPUDialect>();
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<DLTIDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<gpu::GPUDialect>();
    registry.insert<LLVM::LLVMDialect>();
    registry.insert<memref::MemRefDialect>();
    registry.insert<affine::AffineDialect>();
    registry.insert<mhal::MHALDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertRockToGPUPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createConvertRockToGPUPass() {
  return impl::createConvertRockToGPUPass();
}
#undef GEN_PASS_DEF_CONVERTROCKTOGPUPASS
#endif // GEN_PASS_DEF_CONVERTROCKTOGPUPASS

//===----------------------------------------------------------------------===//
// EmulateFp8ExtTruncPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_EMULATEFP8EXTTRUNCPASS
struct EmulateFp8ExtTruncPassOptions {
  bool hasFp8ConversionInstrs = false;
  bool hasOcpFp8ConversionInstrs = false;
};
std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass();
std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass(EmulateFp8ExtTruncPassOptions options);
#undef GEN_PASS_DECL_EMULATEFP8EXTTRUNCPASS
#endif // GEN_PASS_DECL_EMULATEFP8EXTTRUNCPASS
#ifdef GEN_PASS_DEF_EMULATEFP8EXTTRUNCPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass();
} // namespace impl

namespace impl {
  std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass(EmulateFp8ExtTruncPassOptions options);
} // namespace impl
namespace impl {

template <typename DerivedT>
class EmulateFp8ExtTruncPassBase : public ::mlir::OperationPass<> {
public:
  using Base = EmulateFp8ExtTruncPassBase;

  EmulateFp8ExtTruncPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  EmulateFp8ExtTruncPassBase(const EmulateFp8ExtTruncPassBase &other) : ::mlir::OperationPass<>(other) {}
  EmulateFp8ExtTruncPassBase& operator=(const EmulateFp8ExtTruncPassBase &) = delete;
  EmulateFp8ExtTruncPassBase(EmulateFp8ExtTruncPassBase &&) = delete;
  EmulateFp8ExtTruncPassBase& operator=(EmulateFp8ExtTruncPassBase &&) = delete;
  ~EmulateFp8ExtTruncPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("emulate-fp8-ext-trunc");
  }
  ::llvm::StringRef getArgument() const override { return "emulate-fp8-ext-trunc"; }

  ::llvm::StringRef getDescription() const override { return "Emulate arith.extf/truncf on fp8 types"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("EmulateFp8ExtTruncPass");
  }
  ::llvm::StringRef getName() const override { return "EmulateFp8ExtTruncPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<arith::ArithDialect>();
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<memref::MemRefDialect>();
    registry.insert<vector::VectorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(EmulateFp8ExtTruncPassBase<DerivedT>)

  EmulateFp8ExtTruncPassBase(EmulateFp8ExtTruncPassOptions options) : EmulateFp8ExtTruncPassBase() {
    hasFp8ConversionInstrs = std::move(options.hasFp8ConversionInstrs);
    hasOcpFp8ConversionInstrs = std::move(options.hasOcpFp8ConversionInstrs);
  }
protected:
  ::mlir::Pass::Option<bool> hasFp8ConversionInstrs{*this, "f8-conversion-instrs", ::llvm::cl::desc("if the chip has fp8 Nanoo to fp32 conversion instructions or not"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> hasOcpFp8ConversionInstrs{*this, "ocpf8-conversion-instrs", ::llvm::cl::desc("if the chip has OCP fp8 to fp32 conversion instructions or not"), ::llvm::cl::init(false)};
private:

  friend std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass() {
    return std::make_unique<DerivedT>();
  }

  friend std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass(EmulateFp8ExtTruncPassOptions options) {
    return std::make_unique<DerivedT>(std::move(options));
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass() {
  return impl::createEmulateFp8ExtTruncPass();
}

std::unique_ptr<::mlir::Pass> createEmulateFp8ExtTruncPass(EmulateFp8ExtTruncPassOptions options) {
  return impl::createEmulateFp8ExtTruncPass(std::move(options));
}
#undef GEN_PASS_DEF_EMULATEFP8EXTTRUNCPASS
#endif // GEN_PASS_DEF_EMULATEFP8EXTTRUNCPASS

//===----------------------------------------------------------------------===//
// GPUToMIGraphXPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_GPUTOMIGRAPHXPASS
std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass();
#undef GEN_PASS_DECL_GPUTOMIGRAPHXPASS
#endif // GEN_PASS_DECL_GPUTOMIGRAPHXPASS
#ifdef GEN_PASS_DEF_GPUTOMIGRAPHXPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class GPUToMIGraphXPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = GPUToMIGraphXPassBase;

  GPUToMIGraphXPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  GPUToMIGraphXPassBase(const GPUToMIGraphXPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}
  GPUToMIGraphXPassBase& operator=(const GPUToMIGraphXPassBase &) = delete;
  GPUToMIGraphXPassBase(GPUToMIGraphXPassBase &&) = delete;
  GPUToMIGraphXPassBase& operator=(GPUToMIGraphXPassBase &&) = delete;
  ~GPUToMIGraphXPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("gpu-to-migraphx");
  }
  ::llvm::StringRef getArgument() const override { return "gpu-to-migraphx"; }

  ::llvm::StringRef getDescription() const override { return "Lower fused gpu launch to MIGraphX code object"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GPUToMIGraphXPass");
  }
  ::llvm::StringRef getName() const override { return "GPUToMIGraphXPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<migraphx::MIGraphXDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<gpu::GPUDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GPUToMIGraphXPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createGPUToMIGraphXPass() {
  return impl::createGPUToMIGraphXPass();
}
#undef GEN_PASS_DEF_GPUTOMIGRAPHXPASS
#endif // GEN_PASS_DEF_GPUTOMIGRAPHXPASS

//===----------------------------------------------------------------------===//
// MIGraphXToTosaPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass();
#undef GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
#endif // GEN_PASS_DECL_MIGRAPHXTOTOSAPASS
#ifdef GEN_PASS_DEF_MIGRAPHXTOTOSAPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class MIGraphXToTosaPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = MIGraphXToTosaPassBase;

  MIGraphXToTosaPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  MIGraphXToTosaPassBase(const MIGraphXToTosaPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}
  MIGraphXToTosaPassBase& operator=(const MIGraphXToTosaPassBase &) = delete;
  MIGraphXToTosaPassBase(MIGraphXToTosaPassBase &&) = delete;
  MIGraphXToTosaPassBase& operator=(MIGraphXToTosaPassBase &&) = delete;
  ~MIGraphXToTosaPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("migraphx-to-tosa");
  }
  ::llvm::StringRef getArgument() const override { return "migraphx-to-tosa"; }

  ::llvm::StringRef getDescription() const override { return "Lower MIGraphX to TOSA"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MIGraphXToTosaPass");
  }
  ::llvm::StringRef getName() const override { return "MIGraphXToTosaPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<func::FuncDialect>();
    registry.insert<tosa::TosaDialect>();
    registry.insert<mhal::MHALDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MIGraphXToTosaPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createMIGraphXToTosaPass() {
  return impl::createMIGraphXToTosaPass();
}
#undef GEN_PASS_DEF_MIGRAPHXTOTOSAPASS
#endif // GEN_PASS_DEF_MIGRAPHXTOTOSAPASS

//===----------------------------------------------------------------------===//
// RocmlirCustomTosaToLinalgPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_ROCMLIRCUSTOMTOSATOLINALGPASS
std::unique_ptr<::mlir::Pass> createRocmlirCustomTosaToLinalgPass();
#undef GEN_PASS_DECL_ROCMLIRCUSTOMTOSATOLINALGPASS
#endif // GEN_PASS_DECL_ROCMLIRCUSTOMTOSATOLINALGPASS
#ifdef GEN_PASS_DEF_ROCMLIRCUSTOMTOSATOLINALGPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createRocmlirCustomTosaToLinalgPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class RocmlirCustomTosaToLinalgPassBase : public ::mlir::OperationPass<> {
public:
  using Base = RocmlirCustomTosaToLinalgPassBase;

  RocmlirCustomTosaToLinalgPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  RocmlirCustomTosaToLinalgPassBase(const RocmlirCustomTosaToLinalgPassBase &other) : ::mlir::OperationPass<>(other) {}
  RocmlirCustomTosaToLinalgPassBase& operator=(const RocmlirCustomTosaToLinalgPassBase &) = delete;
  RocmlirCustomTosaToLinalgPassBase(RocmlirCustomTosaToLinalgPassBase &&) = delete;
  RocmlirCustomTosaToLinalgPassBase& operator=(RocmlirCustomTosaToLinalgPassBase &&) = delete;
  ~RocmlirCustomTosaToLinalgPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rocmlir-custom-tosa-to-linalg");
  }
  ::llvm::StringRef getArgument() const override { return "rocmlir-custom-tosa-to-linalg"; }

  ::llvm::StringRef getDescription() const override { return "Lower RocMLIR's custom TOSA ops to Linalg"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RocmlirCustomTosaToLinalgPass");
  }
  ::llvm::StringRef getName() const override { return "RocmlirCustomTosaToLinalgPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<arith::ArithDialect>();
    registry.insert<linalg::LinalgDialect>();
    registry.insert<tensor::TensorDialect>();
    registry.insert<tosa::TosaDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RocmlirCustomTosaToLinalgPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createRocmlirCustomTosaToLinalgPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createRocmlirCustomTosaToLinalgPass() {
  return impl::createRocmlirCustomTosaToLinalgPass();
}
#undef GEN_PASS_DEF_ROCMLIRCUSTOMTOSATOLINALGPASS
#endif // GEN_PASS_DEF_ROCMLIRCUSTOMTOSATOLINALGPASS

//===----------------------------------------------------------------------===//
// TosaToRockPass
//===----------------------------------------------------------------------===//
#ifdef GEN_PASS_DECL_TOSATOROCKPASS
std::unique_ptr<::mlir::Pass> createTosaToRockPass();
#undef GEN_PASS_DECL_TOSATOROCKPASS
#endif // GEN_PASS_DECL_TOSATOROCKPASS
#ifdef GEN_PASS_DEF_TOSATOROCKPASS

namespace impl {
  std::unique_ptr<::mlir::Pass> createTosaToRockPass();
} // namespace impl
namespace impl {

template <typename DerivedT>
class TosaToRockPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = TosaToRockPassBase;

  TosaToRockPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  TosaToRockPassBase(const TosaToRockPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}
  TosaToRockPassBase& operator=(const TosaToRockPassBase &) = delete;
  TosaToRockPassBase(TosaToRockPassBase &&) = delete;
  TosaToRockPassBase& operator=(TosaToRockPassBase &&) = delete;
  ~TosaToRockPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tosa-to-rock");
  }
  ::llvm::StringRef getArgument() const override { return "tosa-to-rock"; }

  ::llvm::StringRef getDescription() const override { return "Lower TOSA to Rock"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TosaToRockPass");
  }
  ::llvm::StringRef getName() const override { return "TosaToRockPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Return the dialect that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<bufferization::BufferizationDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<rock::RockDialect>();
    registry.insert<tensor::TensorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TosaToRockPassBase<DerivedT>)

protected:
private:

  friend std::unique_ptr<::mlir::Pass> createTosaToRockPass() {
    return std::make_unique<DerivedT>();
  }
};
} // namespace impl

std::unique_ptr<::mlir::Pass> createTosaToRockPass() {
  return impl::createTosaToRockPass();
}
#undef GEN_PASS_DEF_TOSATOROCKPASS
#endif // GEN_PASS_DEF_TOSATOROCKPASS
#ifdef GEN_PASS_REGISTRATION

//===----------------------------------------------------------------------===//
// ConvertRockToGPUPass Registration
//===----------------------------------------------------------------------===//

inline void registerConvertRockToGPUPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createConvertRockToGPUPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerConvertRockToGPUPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createConvertRockToGPUPass();
  });
}

//===----------------------------------------------------------------------===//
// EmulateFp8ExtTruncPass Registration
//===----------------------------------------------------------------------===//

inline void registerEmulateFp8ExtTruncPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createEmulateFp8ExtTruncPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerEmulateFp8ExtTruncPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createEmulateFp8ExtTruncPass();
  });
}

//===----------------------------------------------------------------------===//
// GPUToMIGraphXPass Registration
//===----------------------------------------------------------------------===//

inline void registerGPUToMIGraphXPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createGPUToMIGraphXPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerGPUToMIGraphXPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createGPUToMIGraphXPass();
  });
}

//===----------------------------------------------------------------------===//
// MIGraphXToTosaPass Registration
//===----------------------------------------------------------------------===//

inline void registerMIGraphXToTosaPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createMIGraphXToTosaPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerMIGraphXToTosaPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createMIGraphXToTosaPass();
  });
}

//===----------------------------------------------------------------------===//
// RocmlirCustomTosaToLinalgPass Registration
//===----------------------------------------------------------------------===//

inline void registerRocmlirCustomTosaToLinalgPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRocmlirCustomTosaToLinalgPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerRocmlirCustomTosaToLinalgPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createRocmlirCustomTosaToLinalgPass();
  });
}

//===----------------------------------------------------------------------===//
// TosaToRockPass Registration
//===----------------------------------------------------------------------===//

inline void registerTosaToRockPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createTosaToRockPass();
  });
}

// Old registration code, kept for temporary backwards compatibility.
inline void registerTosaToRockPassPass() {
  ::mlir::registerPass([]() -> std::unique_ptr<::mlir::Pass> {
    return createTosaToRockPass();
  });
}

//===----------------------------------------------------------------------===//
// RocMLIRConversion Registration
//===----------------------------------------------------------------------===//

inline void registerRocMLIRConversionPasses() {
  registerConvertRockToGPUPass();
  registerEmulateFp8ExtTruncPass();
  registerGPUToMIGraphXPass();
  registerMIGraphXToTosaPass();
  registerRocmlirCustomTosaToLinalgPass();
  registerTosaToRockPass();
}
#undef GEN_PASS_REGISTRATION
#endif // GEN_PASS_REGISTRATION
// Deprecated. Please use the new per-pass macros.
#ifdef GEN_PASS_CLASSES

template <typename DerivedT>
class ConvertRockToGPUPassBase : public ::mlir::OperationPass<ModuleOp> {
public:
  using Base = ConvertRockToGPUPassBase;

  ConvertRockToGPUPassBase() : ::mlir::OperationPass<ModuleOp>(::mlir::TypeID::get<DerivedT>()) {}
  ConvertRockToGPUPassBase(const ConvertRockToGPUPassBase &other) : ::mlir::OperationPass<ModuleOp>(other) {}
  ConvertRockToGPUPassBase& operator=(const ConvertRockToGPUPassBase &) = delete;
  ConvertRockToGPUPassBase(ConvertRockToGPUPassBase &&) = delete;
  ConvertRockToGPUPassBase& operator=(ConvertRockToGPUPassBase &&) = delete;
  ~ConvertRockToGPUPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("convert-rock-to-gpu");
  }
  ::llvm::StringRef getArgument() const override { return "convert-rock-to-gpu"; }

  ::llvm::StringRef getDescription() const override { return "Lower the operations from the Rock dialect into the GPU dialect"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("ConvertRockToGPUPass");
  }
  ::llvm::StringRef getName() const override { return "ConvertRockToGPUPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<rock::RockDialect>();
    registry.insert<amdgpu::AMDGPUDialect>();
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<DLTIDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<gpu::GPUDialect>();
    registry.insert<LLVM::LLVMDialect>();
    registry.insert<memref::MemRefDialect>();
    registry.insert<affine::AffineDialect>();
    registry.insert<mhal::MHALDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(ConvertRockToGPUPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class EmulateFp8ExtTruncPassBase : public ::mlir::OperationPass<> {
public:
  using Base = EmulateFp8ExtTruncPassBase;

  EmulateFp8ExtTruncPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  EmulateFp8ExtTruncPassBase(const EmulateFp8ExtTruncPassBase &other) : ::mlir::OperationPass<>(other) {}
  EmulateFp8ExtTruncPassBase& operator=(const EmulateFp8ExtTruncPassBase &) = delete;
  EmulateFp8ExtTruncPassBase(EmulateFp8ExtTruncPassBase &&) = delete;
  EmulateFp8ExtTruncPassBase& operator=(EmulateFp8ExtTruncPassBase &&) = delete;
  ~EmulateFp8ExtTruncPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("emulate-fp8-ext-trunc");
  }
  ::llvm::StringRef getArgument() const override { return "emulate-fp8-ext-trunc"; }

  ::llvm::StringRef getDescription() const override { return "Emulate arith.extf/truncf on fp8 types"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("EmulateFp8ExtTruncPass");
  }
  ::llvm::StringRef getName() const override { return "EmulateFp8ExtTruncPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<arith::ArithDialect>();
    registry.insert<cf::ControlFlowDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<memref::MemRefDialect>();
    registry.insert<vector::VectorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(EmulateFp8ExtTruncPassBase<DerivedT>)

protected:
  ::mlir::Pass::Option<bool> hasFp8ConversionInstrs{*this, "f8-conversion-instrs", ::llvm::cl::desc("if the chip has fp8 Nanoo to fp32 conversion instructions or not"), ::llvm::cl::init(false)};
  ::mlir::Pass::Option<bool> hasOcpFp8ConversionInstrs{*this, "ocpf8-conversion-instrs", ::llvm::cl::desc("if the chip has OCP fp8 to fp32 conversion instructions or not"), ::llvm::cl::init(false)};
};

template <typename DerivedT>
class GPUToMIGraphXPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = GPUToMIGraphXPassBase;

  GPUToMIGraphXPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  GPUToMIGraphXPassBase(const GPUToMIGraphXPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}
  GPUToMIGraphXPassBase& operator=(const GPUToMIGraphXPassBase &) = delete;
  GPUToMIGraphXPassBase(GPUToMIGraphXPassBase &&) = delete;
  GPUToMIGraphXPassBase& operator=(GPUToMIGraphXPassBase &&) = delete;
  ~GPUToMIGraphXPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("gpu-to-migraphx");
  }
  ::llvm::StringRef getArgument() const override { return "gpu-to-migraphx"; }

  ::llvm::StringRef getDescription() const override { return "Lower fused gpu launch to MIGraphX code object"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("GPUToMIGraphXPass");
  }
  ::llvm::StringRef getName() const override { return "GPUToMIGraphXPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<migraphx::MIGraphXDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<gpu::GPUDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(GPUToMIGraphXPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class MIGraphXToTosaPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = MIGraphXToTosaPassBase;

  MIGraphXToTosaPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  MIGraphXToTosaPassBase(const MIGraphXToTosaPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}
  MIGraphXToTosaPassBase& operator=(const MIGraphXToTosaPassBase &) = delete;
  MIGraphXToTosaPassBase(MIGraphXToTosaPassBase &&) = delete;
  MIGraphXToTosaPassBase& operator=(MIGraphXToTosaPassBase &&) = delete;
  ~MIGraphXToTosaPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("migraphx-to-tosa");
  }
  ::llvm::StringRef getArgument() const override { return "migraphx-to-tosa"; }

  ::llvm::StringRef getDescription() const override { return "Lower MIGraphX to TOSA"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("MIGraphXToTosaPass");
  }
  ::llvm::StringRef getName() const override { return "MIGraphXToTosaPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<func::FuncDialect>();
    registry.insert<tosa::TosaDialect>();
    registry.insert<mhal::MHALDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(MIGraphXToTosaPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class RocmlirCustomTosaToLinalgPassBase : public ::mlir::OperationPass<> {
public:
  using Base = RocmlirCustomTosaToLinalgPassBase;

  RocmlirCustomTosaToLinalgPassBase() : ::mlir::OperationPass<>(::mlir::TypeID::get<DerivedT>()) {}
  RocmlirCustomTosaToLinalgPassBase(const RocmlirCustomTosaToLinalgPassBase &other) : ::mlir::OperationPass<>(other) {}
  RocmlirCustomTosaToLinalgPassBase& operator=(const RocmlirCustomTosaToLinalgPassBase &) = delete;
  RocmlirCustomTosaToLinalgPassBase(RocmlirCustomTosaToLinalgPassBase &&) = delete;
  RocmlirCustomTosaToLinalgPassBase& operator=(RocmlirCustomTosaToLinalgPassBase &&) = delete;
  ~RocmlirCustomTosaToLinalgPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("rocmlir-custom-tosa-to-linalg");
  }
  ::llvm::StringRef getArgument() const override { return "rocmlir-custom-tosa-to-linalg"; }

  ::llvm::StringRef getDescription() const override { return "Lower RocMLIR's custom TOSA ops to Linalg"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("RocmlirCustomTosaToLinalgPass");
  }
  ::llvm::StringRef getName() const override { return "RocmlirCustomTosaToLinalgPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<arith::ArithDialect>();
    registry.insert<linalg::LinalgDialect>();
    registry.insert<tensor::TensorDialect>();
    registry.insert<tosa::TosaDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(RocmlirCustomTosaToLinalgPassBase<DerivedT>)

protected:
};

template <typename DerivedT>
class TosaToRockPassBase : public ::mlir::OperationPass<::mlir::func::FuncOp> {
public:
  using Base = TosaToRockPassBase;

  TosaToRockPassBase() : ::mlir::OperationPass<::mlir::func::FuncOp>(::mlir::TypeID::get<DerivedT>()) {}
  TosaToRockPassBase(const TosaToRockPassBase &other) : ::mlir::OperationPass<::mlir::func::FuncOp>(other) {}
  TosaToRockPassBase& operator=(const TosaToRockPassBase &) = delete;
  TosaToRockPassBase(TosaToRockPassBase &&) = delete;
  TosaToRockPassBase& operator=(TosaToRockPassBase &&) = delete;
  ~TosaToRockPassBase() = default;

  /// Returns the command-line argument attached to this pass.
  static constexpr ::llvm::StringLiteral getArgumentName() {
    return ::llvm::StringLiteral("tosa-to-rock");
  }
  ::llvm::StringRef getArgument() const override { return "tosa-to-rock"; }

  ::llvm::StringRef getDescription() const override { return "Lower TOSA to Rock"; }

  /// Returns the derived pass name.
  static constexpr ::llvm::StringLiteral getPassName() {
    return ::llvm::StringLiteral("TosaToRockPass");
  }
  ::llvm::StringRef getName() const override { return "TosaToRockPass"; }

  /// Support isa/dyn_cast functionality for the derived pass class.
  static bool classof(const ::mlir::Pass *pass) {
    return pass->getTypeID() == ::mlir::TypeID::get<DerivedT>();
  }

  /// A clone method to create a copy of this pass.
  std::unique_ptr<::mlir::Pass> clonePass() const override {
    return std::make_unique<DerivedT>(*static_cast<const DerivedT *>(this));
  }

  /// Register the dialects that must be loaded in the context before this pass.
  void getDependentDialects(::mlir::DialectRegistry &registry) const override {
    registry.insert<bufferization::BufferizationDialect>();
    registry.insert<func::FuncDialect>();
    registry.insert<rock::RockDialect>();
    registry.insert<tensor::TensorDialect>();
  }

  /// Explicitly declare the TypeID for this class. We declare an explicit private
  /// instantiation because Pass classes should only be visible by the current
  /// library.
  MLIR_DEFINE_EXPLICIT_INTERNAL_INLINE_TYPE_ID(TosaToRockPassBase<DerivedT>)

protected:
};
#undef GEN_PASS_CLASSES
#endif // GEN_PASS_CLASSES
