/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Enum Utility Declarations                                                  *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|* From: MIGraphXTypes.td                                                     *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
namespace migraphx {
// enum padding mode for the pad OP
enum class pad_op_mode_t : uint32_t {
  constant_pad = 0,
  reflect_pad = 1,
  edge_pad = 2,
};

::std::optional<pad_op_mode_t> symbolizepad_op_mode_t(uint32_t);
::llvm::StringRef stringifypad_op_mode_t(pad_op_mode_t);
::std::optional<pad_op_mode_t> symbolizepad_op_mode_t(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForpad_op_mode_t() {
  return 2;
}


inline ::llvm::StringRef stringifyEnum(pad_op_mode_t enumValue) {
  return stringifypad_op_mode_t(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<pad_op_mode_t> symbolizeEnum<pad_op_mode_t>(::llvm::StringRef str) {
  return symbolizepad_op_mode_t(str);
}

class pad_op_mode_tAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = pad_op_mode_t;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static pad_op_mode_tAttr get(::mlir::MLIRContext *context, pad_op_mode_t val);
  pad_op_mode_t getValue() const;
};
} // namespace migraphx
} // namespace mlir

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<mlir::migraphx::pad_op_mode_t, mlir::migraphx::pad_op_mode_t> {
  template <typename ParserT>
  static FailureOr<mlir::migraphx::pad_op_mode_t> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for enum padding mode for the pad OP");

    // Symbolize the keyword.
    if (::std::optional<mlir::migraphx::pad_op_mode_t> attr = mlir::migraphx::symbolizeEnum<mlir::migraphx::pad_op_mode_t>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid enum padding mode for the pad OP specification: ") << enumKeyword;
  }
};

/// Support for std::optional, useful in attribute/type definition where the enum is
/// used as:
///
///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
template<>
struct FieldParser<std::optional<mlir::migraphx::pad_op_mode_t>, std::optional<mlir::migraphx::pad_op_mode_t>> {
  template <typename ParserT>
  static FailureOr<std::optional<mlir::migraphx::pad_op_mode_t>> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return std::optional<mlir::migraphx::pad_op_mode_t>{};

    // Symbolize the keyword.
    if (::std::optional<mlir::migraphx::pad_op_mode_t> attr = mlir::migraphx::symbolizeEnum<mlir::migraphx::pad_op_mode_t>(enumKeyword))
      return attr;
    return parser.emitError(loc, "invalid enum padding mode for the pad OP specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, mlir::migraphx::pad_op_mode_t value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<mlir::migraphx::pad_op_mode_t> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline mlir::migraphx::pad_op_mode_t getEmptyKey() {
    return static_cast<mlir::migraphx::pad_op_mode_t>(StorageInfo::getEmptyKey());
  }

  static inline mlir::migraphx::pad_op_mode_t getTombstoneKey() {
    return static_cast<mlir::migraphx::pad_op_mode_t>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const mlir::migraphx::pad_op_mode_t &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const mlir::migraphx::pad_op_mode_t &lhs, const mlir::migraphx::pad_op_mode_t &rhs) {
    return lhs == rhs;
  }
};
}

namespace mlir {
namespace migraphx {
// generic enum padding mode for the OPs
enum class padding_mode_t : uint32_t {
  default_ = 0,
  same = 1,
  valid = 2,
};

::std::optional<padding_mode_t> symbolizepadding_mode_t(uint32_t);
::llvm::StringRef stringifypadding_mode_t(padding_mode_t);
::std::optional<padding_mode_t> symbolizepadding_mode_t(::llvm::StringRef);
inline constexpr unsigned getMaxEnumValForpadding_mode_t() {
  return 2;
}


inline ::llvm::StringRef stringifyEnum(padding_mode_t enumValue) {
  return stringifypadding_mode_t(enumValue);
}

template <typename EnumType>
::std::optional<EnumType> symbolizeEnum(::llvm::StringRef);

template <>
inline ::std::optional<padding_mode_t> symbolizeEnum<padding_mode_t>(::llvm::StringRef str) {
  return symbolizepadding_mode_t(str);
}

class padding_mode_tAttr : public ::mlir::IntegerAttr {
public:
  using ValueType = padding_mode_t;
  using ::mlir::IntegerAttr::IntegerAttr;
  static bool classof(::mlir::Attribute attr);
  static padding_mode_tAttr get(::mlir::MLIRContext *context, padding_mode_t val);
  padding_mode_t getValue() const;
};
} // namespace migraphx
} // namespace mlir

namespace mlir {
template <typename T, typename>
struct FieldParser;

template<>
struct FieldParser<mlir::migraphx::padding_mode_t, mlir::migraphx::padding_mode_t> {
  template <typename ParserT>
  static FailureOr<mlir::migraphx::padding_mode_t> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return parser.emitError(loc, "expected keyword for generic enum padding mode for the OPs");

    // Symbolize the keyword.
    if (::std::optional<mlir::migraphx::padding_mode_t> attr = mlir::migraphx::symbolizeEnum<mlir::migraphx::padding_mode_t>(enumKeyword))
      return *attr;
    return parser.emitError(loc, "invalid generic enum padding mode for the OPs specification: ") << enumKeyword;
  }
};

/// Support for std::optional, useful in attribute/type definition where the enum is
/// used as:
///
///    let parameters = (ins OptionalParameter<"std::optional<TheEnumName>">:$value);
template<>
struct FieldParser<std::optional<mlir::migraphx::padding_mode_t>, std::optional<mlir::migraphx::padding_mode_t>> {
  template <typename ParserT>
  static FailureOr<std::optional<mlir::migraphx::padding_mode_t>> parse(ParserT &parser) {
    // Parse the keyword/string containing the enum.
    std::string enumKeyword;
    auto loc = parser.getCurrentLocation();
    if (failed(parser.parseOptionalKeywordOrString(&enumKeyword)))
      return std::optional<mlir::migraphx::padding_mode_t>{};

    // Symbolize the keyword.
    if (::std::optional<mlir::migraphx::padding_mode_t> attr = mlir::migraphx::symbolizeEnum<mlir::migraphx::padding_mode_t>(enumKeyword))
      return attr;
    return parser.emitError(loc, "invalid generic enum padding mode for the OPs specification: ") << enumKeyword;
  }
};
} // namespace mlir

namespace llvm {
inline ::llvm::raw_ostream &operator<<(::llvm::raw_ostream &p, mlir::migraphx::padding_mode_t value) {
  auto valueStr = stringifyEnum(value);
  return p << valueStr;
}
} // namespace llvm

namespace llvm {
template<> struct DenseMapInfo<mlir::migraphx::padding_mode_t> {
  using StorageInfo = ::llvm::DenseMapInfo<uint32_t>;

  static inline mlir::migraphx::padding_mode_t getEmptyKey() {
    return static_cast<mlir::migraphx::padding_mode_t>(StorageInfo::getEmptyKey());
  }

  static inline mlir::migraphx::padding_mode_t getTombstoneKey() {
    return static_cast<mlir::migraphx::padding_mode_t>(StorageInfo::getTombstoneKey());
  }

  static unsigned getHashValue(const mlir::migraphx::padding_mode_t &val) {
    return StorageInfo::getHashValue(static_cast<uint32_t>(val));
  }

  static bool isEqual(const mlir::migraphx::padding_mode_t &lhs, const mlir::migraphx::padding_mode_t &rhs) {
    return lhs == rhs;
  }
};
}

