/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Definitions                                                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_LIST
#undef GET_TYPEDEF_LIST

mlir::migraphx::MIXRShapedType

#endif  // GET_TYPEDEF_LIST

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES

static ::mlir::OptionalParseResult generatedTypeParser(::mlir::AsmParser &parser, ::llvm::StringRef *mnemonic, ::mlir::Type &value) {
  return ::mlir::AsmParser::KeywordSwitch<::mlir::OptionalParseResult>(parser)
    .Case(mlir::migraphx::MIXRShapedType::getMnemonic(), [&](llvm::StringRef, llvm::SMLoc) {
      value = mlir::migraphx::MIXRShapedType::parse(parser);
      return ::mlir::success(!!value);
    })
    .Default([&](llvm::StringRef keyword, llvm::SMLoc) {
      *mnemonic = keyword;
      return std::nullopt;
    });
}

static ::llvm::LogicalResult generatedTypePrinter(::mlir::Type def, ::mlir::AsmPrinter &printer) {
  return ::llvm::TypeSwitch<::mlir::Type, ::llvm::LogicalResult>(def)    .Case<mlir::migraphx::MIXRShapedType>([&](auto t) {
      printer << mlir::migraphx::MIXRShapedType::getMnemonic();
t.print(printer);
      return ::mlir::success();
    })
    .Default([](auto) { return ::mlir::failure(); });
}

namespace mlir {
namespace migraphx {
namespace detail {
struct MIXRShapedTypeStorage : public ::mlir::TypeStorage {
  using KeyTy = std::tuple<::llvm::ArrayRef<int64_t>, ::llvm::ArrayRef<int64_t>, Type>;
  MIXRShapedTypeStorage(::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, Type elementType) : shape(std::move(shape)), strides(std::move(strides)), elementType(std::move(elementType)) {}

  KeyTy getAsKey() const {
    return KeyTy(shape, strides, elementType);
  }

  bool operator==(const KeyTy &tblgenKey) const {
    return (shape == std::get<0>(tblgenKey)) && (strides == std::get<1>(tblgenKey)) && (elementType == std::get<2>(tblgenKey));
  }

  static ::llvm::hash_code hashKey(const KeyTy &tblgenKey) {
    return ::llvm::hash_combine(std::get<0>(tblgenKey), std::get<1>(tblgenKey), std::get<2>(tblgenKey));
  }

  static MIXRShapedTypeStorage *construct(::mlir::TypeStorageAllocator &allocator, KeyTy &&tblgenKey) {
    auto shape = std::move(std::get<0>(tblgenKey));
    auto strides = std::move(std::get<1>(tblgenKey));
    auto elementType = std::move(std::get<2>(tblgenKey));
    shape = allocator.copyInto(shape);
    strides = allocator.copyInto(strides);
    return new (allocator.allocate<MIXRShapedTypeStorage>()) MIXRShapedTypeStorage(std::move(shape), std::move(strides), std::move(elementType));
  }

  ::llvm::ArrayRef<int64_t> shape;
  ::llvm::ArrayRef<int64_t> strides;
  Type elementType;
};
} // namespace detail
MIXRShapedType MIXRShapedType::get(::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, ::mlir::Type elementType) {
  return Base::get(elementType.getContext(), shape, strides, elementType);
}

MIXRShapedType MIXRShapedType::getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, ::mlir::Type elementType) {
  return Base::getChecked(emitError, elementType.getContext(), shape, strides, elementType);
}

::llvm::LogicalResult MIXRShapedType::verifyInvariants(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, Type elementType) {
  if (::mlir::failed(verify(emitError, shape, strides, elementType)))
    return ::mlir::failure();
  return ::mlir::success();
}

::llvm::ArrayRef<int64_t> MIXRShapedType::getShape() const {
  return getImpl()->shape;
}

::llvm::ArrayRef<int64_t> MIXRShapedType::getStrides() const {
  return getImpl()->strides;
}

Type MIXRShapedType::getElementType() const {
  return getImpl()->elementType;
}

} // namespace migraphx
} // namespace mlir
MLIR_DEFINE_EXPLICIT_TYPE_ID(mlir::migraphx::MIXRShapedType)
namespace mlir {
namespace migraphx {

/// Parse a type registered to this dialect.
::mlir::Type MIGraphXDialect::parseType(::mlir::DialectAsmParser &parser) const {
  ::llvm::SMLoc typeLoc = parser.getCurrentLocation();
  ::llvm::StringRef mnemonic;
  ::mlir::Type genType;
  auto parseResult = generatedTypeParser(parser, &mnemonic, genType);
  if (parseResult.has_value())
    return genType;
  
  parser.emitError(typeLoc) << "unknown  type `"
      << mnemonic << "` in dialect `" << getNamespace() << "`";
  return {};
}
/// Print a type registered to this dialect.
void MIGraphXDialect::printType(::mlir::Type type,
                    ::mlir::DialectAsmPrinter &printer) const {
  if (::mlir::succeeded(generatedTypePrinter(type, printer)))
    return;
  
}
} // namespace migraphx
} // namespace mlir

#endif  // GET_TYPEDEF_CLASSES

