/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace mlir {
namespace migraphx {
class MIXRShapedType;
namespace detail {
struct MIXRShapedTypeStorage;
} // namespace detail
class MIXRShapedType : public ::mlir::Type::TypeBase<MIXRShapedType, ::mlir::Type, detail::MIXRShapedTypeStorage, ::mlir::ShapedType::Trait> {
public:
  using Base::Base;
  using ShapedType::Trait<MIXRShapedType>::getElementTypeBitWidth;
  using ShapedType::Trait<MIXRShapedType>::getRank;
  using ShapedType::Trait<MIXRShapedType>::getNumElements;
  using ShapedType::Trait<MIXRShapedType>::isDynamicDim;
  using ShapedType::Trait<MIXRShapedType>::hasStaticShape;
  using ShapedType::Trait<MIXRShapedType>::getNumDynamicDims;
  using ShapedType::Trait<MIXRShapedType>::getDimSize;
  using ShapedType::Trait<MIXRShapedType>::getDynamicDimIndex;

  ::mlir::RankedTensorType asTensor() const;

  // Returns true if the given shaped type is in standard shape - that is,
  // the strides are in decreasing order and there's a dimension with
  // stride 1.
  bool isStandard() const;

  // Returns true if any stride is 0, indicating that a dimension of this
  // shaped value is broadcast.
  bool hasBroadcast() const;

  // Return the set of dimensions in this type which are broadcast.
  void getBroadcastDims(::llvm::SmallVectorImpl<uint32_t>& result) const;

  // Clone with the given sizes, strides, and element type if present.
  MIXRShapedType cloneWith(std::optional<::llvm::ArrayRef<int64_t>> shape,
                   std::optional<::llvm::ArrayRef<int64_t>> strides,
                   ::mlir::Type elementType) const;

  // Return the tensor type that represent the memory layout specified by this shape.
  // If there is no such tensor, returns nullptr.
  ::mlir::RankedTensorType asMemoryLayoutTensor() const;

  // Return the tensor type that is a 1-D flattening of asMemoryLayoutTensor(),
  // which is used as the actual function argument/result type so that indices
  // are computed efficiently during lowering.
  ::mlir::RankedTensorType asFlatMemoryTensor() const;

  /// Return the permutation that describes how the strides have been permuted
  /// from what they would be if the tensor were in standard shape. This function
  /// is equivalent to MIGraphX's find_Permutation . Applying the inverse
  /// of the permutation returned here to the strides will put them in standard
  /// shape.
  ///
  /// The permutation is an array in the tosa form, that is, given sequences
  /// in and out, we map in[ret[x]] to out[x].
  void getStridePermutation(::llvm::SmallVectorImpl<int64_t>& ret) const;
  static constexpr ::llvm::StringLiteral name = "migraphx.shaped";
  static constexpr ::llvm::StringLiteral dialectName = "migraphx";
  using Base::getChecked;
  static MIXRShapedType get(::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, ::mlir::Type elementType);
  static MIXRShapedType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, ::mlir::Type elementType);
  static ::llvm::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, Type elementType);
  static ::llvm::LogicalResult verifyInvariants(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::llvm::ArrayRef<int64_t> shape, ::llvm::ArrayRef<int64_t> strides, Type elementType);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"shaped"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &odsParser);
  void print(::mlir::AsmPrinter &odsPrinter) const;
  ::llvm::ArrayRef<int64_t> getShape() const;
  ::llvm::ArrayRef<int64_t> getStrides() const;
  Type getElementType() const;
  ::mlir::ShapedType cloneWith(::std::optional<::llvm::ArrayRef<int64_t>> shape, ::mlir::Type elementType) const;
  bool hasRank() const;
};
} // namespace migraphx
} // namespace mlir
MLIR_DECLARE_EXPLICIT_TYPE_ID(mlir::migraphx::MIXRShapedType)

#endif  // GET_TYPEDEF_CLASSES

