/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
namespace rock {
class RockAccelTuningParamAttrInterface;
namespace detail {
struct RockAccelTuningParamAttrInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    int64_t (*getMPerBlock)(const Concept *impl, ::mlir::Attribute );
    int64_t (*getNPerBlock)(const Concept *impl, ::mlir::Attribute );
    int64_t (*getKpackPerBlock)(const Concept *impl, ::mlir::Attribute );
    int64_t (*getMPerWave)(const Concept *impl, ::mlir::Attribute );
    int64_t (*getNPerWave)(const Concept *impl, ::mlir::Attribute );
    /// The base classes of this interface.
    const ::mlir::rock::RockTuningParamAttrInterface::Concept *implRockTuningParamAttrInterface = nullptr;

    void initializeInterfaceConcept(::mlir::detail::InterfaceMap &interfaceMap) {
      implRockTuningParamAttrInterface = interfaceMap.lookup<::mlir::rock::RockTuningParamAttrInterface>();
      assert(implRockTuningParamAttrInterface && "`::mlir::rock::RockAccelTuningParamAttrInterface` expected its base interface `::mlir::rock::RockTuningParamAttrInterface` to be registered");
    }
  };
  template<typename ConcreteAttr>
  class Model : public Concept {
  public:
    using Interface = ::mlir::rock::RockAccelTuningParamAttrInterface;
    Model() : Concept{getMPerBlock, getNPerBlock, getKpackPerBlock, getMPerWave, getNPerWave} {}

    static inline int64_t getMPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getNPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getKpackPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getMPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getNPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
  };
  template<typename ConcreteAttr>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::rock::RockAccelTuningParamAttrInterface;
    FallbackModel() : Concept{getMPerBlock, getNPerBlock, getKpackPerBlock, getMPerWave, getNPerWave} {}

    static inline int64_t getMPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getNPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getKpackPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getMPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getNPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteAttr>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteAttr;
  };
};
template <typename ConcreteAttr>
struct RockAccelTuningParamAttrInterfaceTrait;

} // namespace detail
class RockAccelTuningParamAttrInterface : public ::mlir::AttributeInterface<RockAccelTuningParamAttrInterface, detail::RockAccelTuningParamAttrInterfaceInterfaceTraits> {
public:
  using ::mlir::AttributeInterface<RockAccelTuningParamAttrInterface, detail::RockAccelTuningParamAttrInterfaceInterfaceTraits>::AttributeInterface;
  template <typename ConcreteAttr>
  struct Trait : public detail::RockAccelTuningParamAttrInterfaceTrait<ConcreteAttr> {};
  /// Return how many output rows each block computes. In other words, given that the input block
  /// A layout is `[kOuter, mPerBlock, kpack]`, this method returns `mPerBlock`.
  int64_t getMPerBlock() const;
  /// Return how many output columns each block computes. In other words, given that the input block
  /// A layout is `[kOuter, nPerBlock, kpack]`, this method returns `nPerBlock`.
  int64_t getNPerBlock() const;
  /// Given that the GEMM input blocks layout is `[kOuter, dPerBlock, kPack]` (where `d` can be `m` or `n`)
  /// this method returns `kOuter`.
  int64_t getKpackPerBlock() const;
  /// Return how many output rows each wave computes.
  int64_t getMPerWave() const;
  /// Return how many output columns each wave computes.
  int64_t getNPerWave() const;
  //===----------------------------------------------------------------===//
  // Inherited from ::mlir::rock::RockTuningParamAttrInterface
  //===----------------------------------------------------------------===//

  operator ::mlir::rock::RockTuningParamAttrInterface () const {
    if (!*this) return nullptr;
    return ::mlir::rock::RockTuningParamAttrInterface(*this, getImpl()->implRockTuningParamAttrInterface);
  }

  /// Return serialize perfconfig (comma separated) string
  void getPerfConfigStr(::llvm::SmallVectorImpl<char>& perfStr) const;
  /// Given that the GEMM input blocks layout is `[kOuter, dPerBlock, kPack]` (where `d` can be `m` or `n`)
  /// this method returns `kPack`.
  int64_t getKpack() const;
  /// Flag used to determine if to unroll the loops in MLIR (return `true`) or leave the decision to the back-end (return `false`)
  bool getForceUnroll() const;
  /// Returns splitKFactor
  int64_t getSplitKFactor() const;
};
namespace detail {
  template <typename ConcreteAttr>
  struct RockAccelTuningParamAttrInterfaceTrait : public ::mlir::AttributeInterface<RockAccelTuningParamAttrInterface, detail::RockAccelTuningParamAttrInterfaceInterfaceTraits>::Trait<ConcreteAttr> {
  };
}// namespace detail
} // namespace rock
} // namespace mlir
namespace mlir {
namespace rock {
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getMPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getMPerBlock();
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getNPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getNPerBlock();
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getKpackPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getKpackPerBlock();
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getMPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getMPerWave();
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getNPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getNPerWave();
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getMPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getMPerBlock(tablegen_opaque_val);
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getNPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getNPerBlock(tablegen_opaque_val);
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getKpackPerBlock(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getKpackPerBlock(tablegen_opaque_val);
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getMPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getMPerWave(tablegen_opaque_val);
}
template<typename ConcreteAttr>
int64_t detail::RockAccelTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getNPerWave(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getNPerWave(tablegen_opaque_val);
}
} // namespace rock
} // namespace mlir
