/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
namespace rock {
class RockAcceptingViewOpInterface;
namespace detail {
struct RockAcceptingViewOpInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    Operation *(*cloneWithExtraIndices)(const Concept *impl, ::mlir::Operation *, OpBuilder& , OpOperand&, Value, ArrayRef<Value>);
    std::optional<OperandRange> (*getExtraIndices)(const Concept *impl, ::mlir::Operation *, OpOperand&);
    llvm::SmallPtrSet<OpOperand*, 2> (*getAcceptingViewOperands)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::rock::RockAcceptingViewOpInterface;
    Model() : Concept{cloneWithExtraIndices, getExtraIndices, getAcceptingViewOperands} {}

    static inline Operation *cloneWithExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder&  builder, OpOperand& operand, Value view, ArrayRef<Value> newExtraIndices);
    static inline std::optional<OperandRange> getExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpOperand& operand);
    static inline llvm::SmallPtrSet<OpOperand*, 2> getAcceptingViewOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::rock::RockAcceptingViewOpInterface;
    FallbackModel() : Concept{cloneWithExtraIndices, getExtraIndices, getAcceptingViewOperands} {}

    static inline Operation *cloneWithExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder&  builder, OpOperand& operand, Value view, ArrayRef<Value> newExtraIndices);
    static inline std::optional<OperandRange> getExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpOperand& operand);
    static inline llvm::SmallPtrSet<OpOperand*, 2> getAcceptingViewOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
  };
};
template <typename ConcreteOp>
struct RockAcceptingViewOpInterfaceTrait;

} // namespace detail
class RockAcceptingViewOpInterface : public ::mlir::OpInterface<RockAcceptingViewOpInterface, detail::RockAcceptingViewOpInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<RockAcceptingViewOpInterface, detail::RockAcceptingViewOpInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::RockAcceptingViewOpInterfaceTrait<ConcreteOp> {};
  /// "Clone the operation with a new set of extra indices"
  Operation *cloneWithExtraIndices(OpBuilder&  builder, OpOperand& operand, Value view, ArrayRef<Value> newExtraIndices);
  /// "Return the extra indices used to index the operand accepting the view"
  std::optional<OperandRange> getExtraIndices(OpOperand& operand);
  /// "Return the list of operands that accept a view"
  llvm::SmallPtrSet<OpOperand*, 2> getAcceptingViewOperands();
};
namespace detail {
  template <typename ConcreteOp>
  struct RockAcceptingViewOpInterfaceTrait : public ::mlir::OpInterface<RockAcceptingViewOpInterface, detail::RockAcceptingViewOpInterfaceInterfaceTraits>::Trait<ConcreteOp> {
  };
}// namespace detail
} // namespace rock
} // namespace mlir
namespace mlir {
namespace rock {
template<typename ConcreteOp>
Operation *detail::RockAcceptingViewOpInterfaceInterfaceTraits::Model<ConcreteOp>::cloneWithExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder&  builder, OpOperand& operand, Value view, ArrayRef<Value> newExtraIndices) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).cloneWithExtraIndices(builder, operand, view, newExtraIndices);
}
template<typename ConcreteOp>
std::optional<OperandRange> detail::RockAcceptingViewOpInterfaceInterfaceTraits::Model<ConcreteOp>::getExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpOperand& operand) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getExtraIndices(operand);
}
template<typename ConcreteOp>
llvm::SmallPtrSet<OpOperand*, 2> detail::RockAcceptingViewOpInterfaceInterfaceTraits::Model<ConcreteOp>::getAcceptingViewOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getAcceptingViewOperands();
}
template<typename ConcreteOp>
Operation *detail::RockAcceptingViewOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::cloneWithExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpBuilder&  builder, OpOperand& operand, Value view, ArrayRef<Value> newExtraIndices) {
  return static_cast<const ConcreteOp *>(impl)->cloneWithExtraIndices(tablegen_opaque_val, builder, operand, view, newExtraIndices);
}
template<typename ConcreteOp>
std::optional<OperandRange> detail::RockAcceptingViewOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getExtraIndices(const Concept *impl, ::mlir::Operation *tablegen_opaque_val, OpOperand& operand) {
  return static_cast<const ConcreteOp *>(impl)->getExtraIndices(tablegen_opaque_val, operand);
}
template<typename ConcreteOp>
llvm::SmallPtrSet<OpOperand*, 2> detail::RockAcceptingViewOpInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getAcceptingViewOperands(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getAcceptingViewOperands(tablegen_opaque_val);
}
} // namespace rock
} // namespace mlir
