/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
namespace rock {
class RockConvInterface;
namespace detail {
struct RockConvInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    ::mlir::TypedValue<::mlir::ShapedType> (*getFilter)(const Concept *impl, ::mlir::Operation *);
    ::mlir::TypedValue<::mlir::ShapedType> (*getInput)(const Concept *impl, ::mlir::Operation *);
    ::mlir::TypedValue<::mlir::ShapedType> (*getOutput)(const Concept *impl, ::mlir::Operation *);
    ArrayAttr (*getPadding)(const Concept *impl, ::mlir::Operation *);
    ArrayAttr (*getStrides)(const Concept *impl, ::mlir::Operation *);
    ArrayAttr (*getDilations)(const Concept *impl, ::mlir::Operation *);
    GemmFeatures (*getFeatures)(const Concept *impl, ::mlir::Operation *);
  };
  template<typename ConcreteOp>
  class Model : public Concept {
  public:
    using Interface = ::mlir::rock::RockConvInterface;
    Model() : Concept{getFilter, getInput, getOutput, getPadding, getStrides, getDilations, getFeatures} {}

    static inline ::mlir::TypedValue<::mlir::ShapedType> getFilter(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::TypedValue<::mlir::ShapedType> getInput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::TypedValue<::mlir::ShapedType> getOutput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getPadding(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getStrides(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getDilations(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline GemmFeatures getFeatures(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteOp>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::rock::RockConvInterface;
    FallbackModel() : Concept{getFilter, getInput, getOutput, getPadding, getStrides, getDilations, getFeatures} {}

    static inline ::mlir::TypedValue<::mlir::ShapedType> getFilter(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::TypedValue<::mlir::ShapedType> getInput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ::mlir::TypedValue<::mlir::ShapedType> getOutput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getPadding(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getStrides(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline ArrayAttr getDilations(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
    static inline GemmFeatures getFeatures(const Concept *impl, ::mlir::Operation *tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteOp>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteOp;
    ::mlir::TypedValue<::mlir::ShapedType> getFilter(::mlir::Operation *tablegen_opaque_val) const;
    ::mlir::TypedValue<::mlir::ShapedType> getInput(::mlir::Operation *tablegen_opaque_val) const;
    ::mlir::TypedValue<::mlir::ShapedType> getOutput(::mlir::Operation *tablegen_opaque_val) const;
    ArrayAttr getPadding(::mlir::Operation *tablegen_opaque_val) const;
    ArrayAttr getStrides(::mlir::Operation *tablegen_opaque_val) const;
    ArrayAttr getDilations(::mlir::Operation *tablegen_opaque_val) const;
  };
};
template <typename ConcreteOp>
struct RockConvInterfaceTrait;

} // namespace detail
class RockConvInterface : public ::mlir::OpInterface<RockConvInterface, detail::RockConvInterfaceInterfaceTraits> {
public:
  using ::mlir::OpInterface<RockConvInterface, detail::RockConvInterfaceInterfaceTraits>::OpInterface;
  template <typename ConcreteOp>
  struct Trait : public detail::RockConvInterfaceTrait<ConcreteOp> {};
  /// Return filter tensor.
  ::mlir::TypedValue<::mlir::ShapedType> getFilter();
  /// Return input tensor.
  ::mlir::TypedValue<::mlir::ShapedType> getInput();
  /// Return output tensor.
  ::mlir::TypedValue<::mlir::ShapedType> getOutput();
  /// Return convolution padding values.
  ArrayAttr getPadding();
  /// Return convolution stride values.
  ArrayAttr getStrides();
  /// Return convolution dilation values.
  ArrayAttr getDilations();
  /// Return features attr values.
  GemmFeatures getFeatures();
};
namespace detail {
  template <typename ConcreteOp>
  struct RockConvInterfaceTrait : public ::mlir::OpInterface<RockConvInterface, detail::RockConvInterfaceInterfaceTraits>::Trait<ConcreteOp> {
    /// Return filter tensor.
    ::mlir::TypedValue<::mlir::ShapedType> getFilter() {
      return (*static_cast<ConcreteOp *>(this)).getFilter();
    }
    /// Return input tensor.
    ::mlir::TypedValue<::mlir::ShapedType> getInput() {
      return (*static_cast<ConcreteOp *>(this)).getInput();
    }
    /// Return output tensor.
    ::mlir::TypedValue<::mlir::ShapedType> getOutput() {
      return (*static_cast<ConcreteOp *>(this)).getOutput();
    }
    /// Return convolution padding values.
    ArrayAttr getPadding() {
      return (*static_cast<ConcreteOp *>(this)).getPadding();
    }
    /// Return convolution stride values.
    ArrayAttr getStrides() {
      return (*static_cast<ConcreteOp *>(this)).getStrides();
    }
    /// Return convolution dilation values.
    ArrayAttr getDilations() {
      return (*static_cast<ConcreteOp *>(this)).getDilations();
    }
    static ::llvm::LogicalResult verifyTrait(::mlir::Operation *op) {
      auto concreteOp = ::mlir::cast<ConcreteOp>(op);
    if (op->getNumResults() == 1) {
      if (op->getResult(0).getType() !=
          concreteOp.getOutArgument()->get().getType()) {
        return op->emitOpError("result type must match output argument type");
      }
    }
    return ::mlir::success();
    }
  };
}// namespace detail
} // namespace rock
} // namespace mlir
namespace mlir {
namespace rock {
template<typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::Model<ConcreteOp>::getFilter(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getFilter();
}
template<typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::Model<ConcreteOp>::getInput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInput();
}
template<typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::Model<ConcreteOp>::getOutput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getOutput();
}
template<typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::Model<ConcreteOp>::getPadding(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getPadding();
}
template<typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::Model<ConcreteOp>::getStrides(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getStrides();
}
template<typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::Model<ConcreteOp>::getDilations(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getDilations();
}
template<typename ConcreteOp>
GemmFeatures detail::RockConvInterfaceInterfaceTraits::Model<ConcreteOp>::getFeatures(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getFeatures();
}
template<typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getFilter(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getFilter(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getInput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getInput(tablegen_opaque_val);
}
template<typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getOutput(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getOutput(tablegen_opaque_val);
}
template<typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getPadding(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getPadding(tablegen_opaque_val);
}
template<typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getStrides(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getStrides(tablegen_opaque_val);
}
template<typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getDilations(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getDilations(tablegen_opaque_val);
}
template<typename ConcreteOp>
GemmFeatures detail::RockConvInterfaceInterfaceTraits::FallbackModel<ConcreteOp>::getFeatures(const Concept *impl, ::mlir::Operation *tablegen_opaque_val) {
  return static_cast<const ConcreteOp *>(impl)->getFeatures(tablegen_opaque_val);
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getFilter(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getFilter();
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getInput(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getInput();
}
template<typename ConcreteModel, typename ConcreteOp>
::mlir::TypedValue<::mlir::ShapedType> detail::RockConvInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getOutput(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getOutput();
}
template<typename ConcreteModel, typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getPadding(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getPadding();
}
template<typename ConcreteModel, typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getStrides(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getStrides();
}
template<typename ConcreteModel, typename ConcreteOp>
ArrayAttr detail::RockConvInterfaceInterfaceTraits::ExternalModel<ConcreteModel, ConcreteOp>::getDilations(::mlir::Operation *tablegen_opaque_val) const {
return (llvm::cast<ConcreteOp>(tablegen_opaque_val)).getDilations();
}
} // namespace rock
} // namespace mlir
