/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Interface Declarations                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

namespace mlir {
namespace rock {
class RockTuningParamAttrInterface;
namespace detail {
struct RockTuningParamAttrInterfaceInterfaceTraits {
  struct Concept {
    /// The methods defined by the interface.
    void (*getPerfConfigStr)(const Concept *impl, ::mlir::Attribute , ::llvm::SmallVectorImpl<char>&);
    int64_t (*getKpack)(const Concept *impl, ::mlir::Attribute );
    bool (*getForceUnroll)(const Concept *impl, ::mlir::Attribute );
    int64_t (*getSplitKFactor)(const Concept *impl, ::mlir::Attribute );
  };
  template<typename ConcreteAttr>
  class Model : public Concept {
  public:
    using Interface = ::mlir::rock::RockTuningParamAttrInterface;
    Model() : Concept{getPerfConfigStr, getKpack, getForceUnroll, getSplitKFactor} {}

    static inline void getPerfConfigStr(const Concept *impl, ::mlir::Attribute tablegen_opaque_val, ::llvm::SmallVectorImpl<char>& perfStr);
    static inline int64_t getKpack(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline bool getForceUnroll(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getSplitKFactor(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
  };
  template<typename ConcreteAttr>
  class FallbackModel : public Concept {
  public:
    using Interface = ::mlir::rock::RockTuningParamAttrInterface;
    FallbackModel() : Concept{getPerfConfigStr, getKpack, getForceUnroll, getSplitKFactor} {}

    static inline void getPerfConfigStr(const Concept *impl, ::mlir::Attribute tablegen_opaque_val, ::llvm::SmallVectorImpl<char>& perfStr);
    static inline int64_t getKpack(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline bool getForceUnroll(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
    static inline int64_t getSplitKFactor(const Concept *impl, ::mlir::Attribute tablegen_opaque_val);
  };
  template<typename ConcreteModel, typename ConcreteAttr>
  class ExternalModel : public FallbackModel<ConcreteModel> {
  public:
    using ConcreteEntity = ConcreteAttr;
  };
};
template <typename ConcreteAttr>
struct RockTuningParamAttrInterfaceTrait;

} // namespace detail
class RockTuningParamAttrInterface : public ::mlir::AttributeInterface<RockTuningParamAttrInterface, detail::RockTuningParamAttrInterfaceInterfaceTraits> {
public:
  using ::mlir::AttributeInterface<RockTuningParamAttrInterface, detail::RockTuningParamAttrInterfaceInterfaceTraits>::AttributeInterface;
  template <typename ConcreteAttr>
  struct Trait : public detail::RockTuningParamAttrInterfaceTrait<ConcreteAttr> {};
  /// Return serialize perfconfig (comma separated) string
  void getPerfConfigStr(::llvm::SmallVectorImpl<char>& perfStr) const;
  /// Given that the GEMM input blocks layout is `[kOuter, dPerBlock, kPack]` (where `d` can be `m` or `n`)
  /// this method returns `kPack`.
  int64_t getKpack() const;
  /// Flag used to determine if to unroll the loops in MLIR (return `true`) or leave the decision to the back-end (return `false`)
  bool getForceUnroll() const;
  /// Returns splitKFactor
  int64_t getSplitKFactor() const;
};
namespace detail {
  template <typename ConcreteAttr>
  struct RockTuningParamAttrInterfaceTrait : public ::mlir::AttributeInterface<RockTuningParamAttrInterface, detail::RockTuningParamAttrInterfaceInterfaceTraits>::Trait<ConcreteAttr> {
  };
}// namespace detail
} // namespace rock
} // namespace mlir
namespace mlir {
namespace rock {
template<typename ConcreteAttr>
void detail::RockTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getPerfConfigStr(const Concept *impl, ::mlir::Attribute tablegen_opaque_val, ::llvm::SmallVectorImpl<char>& perfStr) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getPerfConfigStr(perfStr);
}
template<typename ConcreteAttr>
int64_t detail::RockTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getKpack(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getKpack();
}
template<typename ConcreteAttr>
bool detail::RockTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getForceUnroll(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getForceUnroll();
}
template<typename ConcreteAttr>
int64_t detail::RockTuningParamAttrInterfaceInterfaceTraits::Model<ConcreteAttr>::getSplitKFactor(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return (::llvm::cast<ConcreteAttr>(tablegen_opaque_val)).getSplitKFactor();
}
template<typename ConcreteAttr>
void detail::RockTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getPerfConfigStr(const Concept *impl, ::mlir::Attribute tablegen_opaque_val, ::llvm::SmallVectorImpl<char>& perfStr) {
  return static_cast<const ConcreteAttr *>(impl)->getPerfConfigStr(tablegen_opaque_val, perfStr);
}
template<typename ConcreteAttr>
int64_t detail::RockTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getKpack(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getKpack(tablegen_opaque_val);
}
template<typename ConcreteAttr>
bool detail::RockTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getForceUnroll(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getForceUnroll(tablegen_opaque_val);
}
template<typename ConcreteAttr>
int64_t detail::RockTuningParamAttrInterfaceInterfaceTraits::FallbackModel<ConcreteAttr>::getSplitKFactor(const Concept *impl, ::mlir::Attribute tablegen_opaque_val) {
  return static_cast<const ConcreteAttr *>(impl)->getSplitKFactor(tablegen_opaque_val);
}
} // namespace rock
} // namespace mlir
