/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AttrDef Definitions                                                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_ATTRDEF_LIST
#undef GET_ATTRDEF_LIST

::mlir::mhal::TargetObjectAttr,
::mlir::mhal::KernelPackageAttr,
::mlir::mhal::PrefillAttr

#endif  // GET_ATTRDEF_LIST

#ifdef GET_ATTRDEF_CLASSES
#undef GET_ATTRDEF_CLASSES

static ::mlir::OptionalParseResult generatedAttributeParser(::mlir::AsmParser &parser, ::llvm::StringRef *mnemonic, ::mlir::Type type, ::mlir::Attribute &value) {
  return ::mlir::AsmParser::KeywordSwitch<::mlir::OptionalParseResult>(parser)
    .Case(::mlir::mhal::TargetObjectAttr::getMnemonic(), [&](llvm::StringRef, llvm::SMLoc) {
      value = ::mlir::mhal::TargetObjectAttr::parse(parser, type);
      return ::mlir::success(!!value);
    })
    .Case(::mlir::mhal::KernelPackageAttr::getMnemonic(), [&](llvm::StringRef, llvm::SMLoc) {
      value = ::mlir::mhal::KernelPackageAttr::parse(parser, type);
      return ::mlir::success(!!value);
    })
    .Case(::mlir::mhal::PrefillAttr::getMnemonic(), [&](llvm::StringRef, llvm::SMLoc) {
      value = ::mlir::mhal::PrefillAttr::parse(parser, type);
      return ::mlir::success(!!value);
    })
    .Default([&](llvm::StringRef keyword, llvm::SMLoc) {
      *mnemonic = keyword;
      return std::nullopt;
    });
}

static ::llvm::LogicalResult generatedAttributePrinter(::mlir::Attribute def, ::mlir::AsmPrinter &printer) {
  return ::llvm::TypeSwitch<::mlir::Attribute, ::llvm::LogicalResult>(def)    .Case<::mlir::mhal::TargetObjectAttr>([&](auto t) {
      printer << ::mlir::mhal::TargetObjectAttr::getMnemonic();
t.print(printer);
      return ::mlir::success();
    })
    .Case<::mlir::mhal::KernelPackageAttr>([&](auto t) {
      printer << ::mlir::mhal::KernelPackageAttr::getMnemonic();
t.print(printer);
      return ::mlir::success();
    })
    .Case<::mlir::mhal::PrefillAttr>([&](auto t) {
      printer << ::mlir::mhal::PrefillAttr::getMnemonic();
t.print(printer);
      return ::mlir::success();
    })
    .Default([](auto) { return ::mlir::failure(); });
}

namespace mlir {
namespace mhal {
namespace detail {
struct TargetObjectAttrStorage : public ::mlir::AttributeStorage {
  using KeyTy = std::tuple<::mlir::mhal::TargetObjectType, ::llvm::StringRef, DictionaryAttr, Attribute>;
  TargetObjectAttrStorage(::mlir::mhal::TargetObjectType type, ::llvm::StringRef arch, DictionaryAttr attributes, Attribute binary) : type(std::move(type)), arch(std::move(arch)), attributes(std::move(attributes)), binary(std::move(binary)) {}

  KeyTy getAsKey() const {
    return KeyTy(type, arch, attributes, binary);
  }

  bool operator==(const KeyTy &tblgenKey) const {
    return (type == std::get<0>(tblgenKey)) && (arch == std::get<1>(tblgenKey)) && (attributes == std::get<2>(tblgenKey)) && (binary == std::get<3>(tblgenKey));
  }

  static ::llvm::hash_code hashKey(const KeyTy &tblgenKey) {
    return ::llvm::hash_combine(std::get<0>(tblgenKey), std::get<1>(tblgenKey), std::get<2>(tblgenKey), std::get<3>(tblgenKey));
  }

  static TargetObjectAttrStorage *construct(::mlir::AttributeStorageAllocator &allocator, KeyTy &&tblgenKey) {
    auto type = std::move(std::get<0>(tblgenKey));
    auto arch = std::move(std::get<1>(tblgenKey));
    auto attributes = std::move(std::get<2>(tblgenKey));
    auto binary = std::move(std::get<3>(tblgenKey));
    arch = allocator.copyInto(arch);
    return new (allocator.allocate<TargetObjectAttrStorage>()) TargetObjectAttrStorage(std::move(type), std::move(arch), std::move(attributes), std::move(binary));
  }

  ::mlir::mhal::TargetObjectType type;
  ::llvm::StringRef arch;
  DictionaryAttr attributes;
  Attribute binary;
};
} // namespace detail
TargetObjectAttr TargetObjectAttr::get(::mlir::MLIRContext *context, ::mlir::mhal::TargetObjectType type, ::llvm::StringRef arch, DictionaryAttr attributes, Attribute binary) {
  return Base::get(context, std::move(type), std::move(arch), std::move(attributes), std::move(binary));
}

::mlir::mhal::TargetObjectType TargetObjectAttr::getType() const {
  return getImpl()->type;
}

::llvm::StringRef TargetObjectAttr::getArch() const {
  return getImpl()->arch;
}

DictionaryAttr TargetObjectAttr::getAttributes() const {
  return getImpl()->attributes;
}

Attribute TargetObjectAttr::getBinary() const {
  return getImpl()->binary;
}

} // namespace mhal
} // namespace mlir
MLIR_DEFINE_EXPLICIT_TYPE_ID(::mlir::mhal::TargetObjectAttr)
namespace mlir {
namespace mhal {
namespace detail {
struct KernelPackageAttrStorage : public ::mlir::AttributeStorage {
  using KeyTy = std::tuple<::mlir::mhal::TargetType, ::llvm::StringRef, ::llvm::StringRef, ::llvm::ArrayRef<uint32_t>, DictionaryAttr, ::mlir::mhal::TargetObjectAttr>;
  KernelPackageAttrStorage(::mlir::mhal::TargetType type, ::llvm::StringRef target, ::llvm::StringRef kernel_name, ::llvm::ArrayRef<uint32_t> launch_dims, DictionaryAttr attributes, ::mlir::mhal::TargetObjectAttr object) : type(std::move(type)), target(std::move(target)), kernel_name(std::move(kernel_name)), launch_dims(std::move(launch_dims)), attributes(std::move(attributes)), object(std::move(object)) {}

  KeyTy getAsKey() const {
    return KeyTy(type, target, kernel_name, launch_dims, attributes, object);
  }

  bool operator==(const KeyTy &tblgenKey) const {
    return (type == std::get<0>(tblgenKey)) && (target == std::get<1>(tblgenKey)) && (kernel_name == std::get<2>(tblgenKey)) && (launch_dims == std::get<3>(tblgenKey)) && (attributes == std::get<4>(tblgenKey)) && (object == std::get<5>(tblgenKey));
  }

  static ::llvm::hash_code hashKey(const KeyTy &tblgenKey) {
    return ::llvm::hash_combine(std::get<0>(tblgenKey), std::get<1>(tblgenKey), std::get<2>(tblgenKey), std::get<3>(tblgenKey), std::get<4>(tblgenKey), std::get<5>(tblgenKey));
  }

  static KernelPackageAttrStorage *construct(::mlir::AttributeStorageAllocator &allocator, KeyTy &&tblgenKey) {
    auto type = std::move(std::get<0>(tblgenKey));
    auto target = std::move(std::get<1>(tblgenKey));
    auto kernel_name = std::move(std::get<2>(tblgenKey));
    auto launch_dims = std::move(std::get<3>(tblgenKey));
    auto attributes = std::move(std::get<4>(tblgenKey));
    auto object = std::move(std::get<5>(tblgenKey));
    target = allocator.copyInto(target);
    kernel_name = allocator.copyInto(kernel_name);
    launch_dims = allocator.copyInto(launch_dims);
    return new (allocator.allocate<KernelPackageAttrStorage>()) KernelPackageAttrStorage(std::move(type), std::move(target), std::move(kernel_name), std::move(launch_dims), std::move(attributes), std::move(object));
  }

  ::mlir::mhal::TargetType type;
  ::llvm::StringRef target;
  ::llvm::StringRef kernel_name;
  ::llvm::ArrayRef<uint32_t> launch_dims;
  DictionaryAttr attributes;
  ::mlir::mhal::TargetObjectAttr object;
};
} // namespace detail
KernelPackageAttr KernelPackageAttr::get(::mlir::MLIRContext *context, ::mlir::mhal::TargetType type, ::llvm::StringRef target, ::llvm::StringRef kernel_name, ::llvm::ArrayRef<uint32_t> launch_dims, DictionaryAttr attributes, ::mlir::mhal::TargetObjectAttr object) {
  return Base::get(context, std::move(type), std::move(target), std::move(kernel_name), std::move(launch_dims), std::move(attributes), std::move(object));
}

::mlir::mhal::TargetType KernelPackageAttr::getType() const {
  return getImpl()->type;
}

::llvm::StringRef KernelPackageAttr::getTarget() const {
  return getImpl()->target;
}

::llvm::StringRef KernelPackageAttr::getKernelName() const {
  return getImpl()->kernel_name;
}

::llvm::ArrayRef<uint32_t> KernelPackageAttr::getLaunchDims() const {
  return getImpl()->launch_dims;
}

DictionaryAttr KernelPackageAttr::getAttributes() const {
  return getImpl()->attributes;
}

::mlir::mhal::TargetObjectAttr KernelPackageAttr::getObject() const {
  return getImpl()->object;
}

} // namespace mhal
} // namespace mlir
MLIR_DEFINE_EXPLICIT_TYPE_ID(::mlir::mhal::KernelPackageAttr)
namespace mlir {
namespace mhal {
namespace detail {
struct PrefillAttrStorage : public ::mlir::AttributeStorage {
  using KeyTy = std::tuple<uint32_t, TypedAttr>;
  PrefillAttrStorage(uint32_t argIndex, TypedAttr initValue) : argIndex(std::move(argIndex)), initValue(std::move(initValue)) {}

  KeyTy getAsKey() const {
    return KeyTy(argIndex, initValue);
  }

  bool operator==(const KeyTy &tblgenKey) const {
    return (argIndex == std::get<0>(tblgenKey)) && (initValue == std::get<1>(tblgenKey));
  }

  static ::llvm::hash_code hashKey(const KeyTy &tblgenKey) {
    return ::llvm::hash_combine(std::get<0>(tblgenKey), std::get<1>(tblgenKey));
  }

  static PrefillAttrStorage *construct(::mlir::AttributeStorageAllocator &allocator, KeyTy &&tblgenKey) {
    auto argIndex = std::move(std::get<0>(tblgenKey));
    auto initValue = std::move(std::get<1>(tblgenKey));
    return new (allocator.allocate<PrefillAttrStorage>()) PrefillAttrStorage(std::move(argIndex), std::move(initValue));
  }

  uint32_t argIndex;
  TypedAttr initValue;
};
} // namespace detail
PrefillAttr PrefillAttr::get(::mlir::MLIRContext *context, uint32_t argIndex, TypedAttr initValue) {
  return Base::get(context, std::move(argIndex), std::move(initValue));
}

::mlir::Attribute PrefillAttr::parse(::mlir::AsmParser &odsParser, ::mlir::Type odsType) {
  ::mlir::Builder odsBuilder(odsParser.getContext());
  ::llvm::SMLoc odsLoc = odsParser.getCurrentLocation();
  (void) odsLoc;
  ::mlir::FailureOr<uint32_t> _result_argIndex;
  ::mlir::FailureOr<TypedAttr> _result_initValue;
  // Parse literal '<'
  if (odsParser.parseLess()) return {};
  // Parse parameter list

  // Parse variable 'argIndex'
  _result_argIndex = ::mlir::FieldParser<uint32_t>::parse(odsParser);
  if (::mlir::failed(_result_argIndex)) {
    odsParser.emitError(odsParser.getCurrentLocation(), "failed to parse MHAL_PrefillAttr parameter 'argIndex' which is to be a `uint32_t`");
    return {};
  }
  // Parse literal ','
  if (odsParser.parseComma()) return {};

  // Parse variable 'initValue'
  _result_initValue = ::mlir::FieldParser<TypedAttr>::parse(odsParser);
  if (::mlir::failed(_result_initValue)) {
    odsParser.emitError(odsParser.getCurrentLocation(), "failed to parse MHAL_PrefillAttr parameter 'initValue' which is to be a `TypedAttr`");
    return {};
  }
  // Parse literal '>'
  if (odsParser.parseGreater()) return {};
  assert(::mlir::succeeded(_result_argIndex));
  assert(::mlir::succeeded(_result_initValue));
  return PrefillAttr::get(odsParser.getContext(),
      uint32_t((*_result_argIndex)),
      TypedAttr((*_result_initValue)));
}

void PrefillAttr::print(::mlir::AsmPrinter &odsPrinter) const {
  ::mlir::Builder odsBuilder(getContext());
  odsPrinter << "<";
  {
    bool _firstPrinted = true;
    if (!_firstPrinted) odsPrinter << ", ";
    _firstPrinted = false;
    odsPrinter.printStrippedAttrOrType(getArgIndex());
    if (!_firstPrinted) odsPrinter << ", ";
    _firstPrinted = false;
    odsPrinter.printStrippedAttrOrType(getInitValue());
  }
  odsPrinter << ">";
}

uint32_t PrefillAttr::getArgIndex() const {
  return getImpl()->argIndex;
}

TypedAttr PrefillAttr::getInitValue() const {
  return getImpl()->initValue;
}

} // namespace mhal
} // namespace mlir
MLIR_DEFINE_EXPLICIT_TYPE_ID(::mlir::mhal::PrefillAttr)
namespace mlir {
namespace mhal {

/// Parse an attribute registered to this dialect.
::mlir::Attribute MHALDialect::parseAttribute(::mlir::DialectAsmParser &parser,
                                      ::mlir::Type type) const {
  ::llvm::SMLoc typeLoc = parser.getCurrentLocation();
  ::llvm::StringRef attrTag;
  {
    ::mlir::Attribute attr;
    auto parseResult = generatedAttributeParser(parser, &attrTag, type, attr);
    if (parseResult.has_value())
      return attr;
  }
  
  parser.emitError(typeLoc) << "unknown attribute `"
      << attrTag << "` in dialect `" << getNamespace() << "`";
  return {};
}
/// Print an attribute registered to this dialect.
void MHALDialect::printAttribute(::mlir::Attribute attr,
                         ::mlir::DialectAsmPrinter &printer) const {
  if (::mlir::succeeded(generatedAttributePrinter(attr, printer)))
    return;
  
}
} // namespace mhal
} // namespace mlir

#endif  // GET_ATTRDEF_CLASSES

