//===- RockTypes.h - Rock enums and types ---------===//
//
// Part of the rocMLIR Project, under the Apache License v2.0 with LLVM
// Exceptions. See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
// Copyright (c) 2022 Advanced Micro Devices INc.
//===----------------------------------------------------------------------===//
//
// A header to guard against multi-including the autogenerated enums of the Rock
// dialect
//
//===----------------------------------------------------------------------===//

#ifndef MLIR_DIALECT_ROCK_IR_ROCKTYPES_H
#define MLIR_DIALECT_ROCK_IR_ROCKTYPES_H

#include "mlir/IR/OpDefinition.h"

#include "mlir/Dialect/Rock/IR/RockTypes.h.inc"

namespace mlir {
namespace rock {
ConvOpType convOpTypeFromKernelType(KernelType kernelType);
KernelType kernelTypeFromConvOpType(ConvOpType convOpType);
} // namespace rock
} // namespace mlir

#endif // MLIR_DILACET_ROCK_IR_ROCKTYPES_H
